/**
 *
 * This file is part of Porgy (http://tulip.labri.fr/TulipDrupal/?q=porgy)
 *
 * from LaBRI, University of Bordeaux, Inria and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "InteractorPortGraphDelElementComponent.h"
#include "../../StandardInteractorPriority.h"

#include <tulip/MouseInteractors.h>
#include <tulip/View.h>
#include <tulip/Graph.h>
#include <tulip/NodeLinkDiagramComponentInteractor.h>

#include <portgraph/PorgyTlpGraphStructure.h>

using namespace tlp;
using namespace std;

class PortGraphDelElement  : public tlp::NodeLinkDiagramComponentInteractor {

public :
    PLUGININFORMATION("PortGraphDelElement", "Tulip Team", "01/04/2009", "Delete Element in a PortGraph Interactor", "1.0",PorgyConstants::CATEGORY_NAME)

    PortGraphDelElement(const PluginContext *):NodeLinkDiagramComponentInteractor(":/tulip/gui/icons/i_del.png","Delete portnodes or edges between portnodes"){
        setConfigurationWidgetText(QString("<h3>Delete interactor</h3>")+
            "<b>Mouse left</b> click on an element to delete it");
    setPriority(StandardInteractorPriority::DeleteElement);
    }

    bool isCompatible(const std::string &viewName) const {
            return ((viewName==PorgyConstants::GRAPH_VIEW_NAME)||(viewName==PorgyConstants::RULE_VIEW_NAME));

    }

    void construct(){
        push_front(new MousePanNZoomNavigator);
        push_front(new PortGraphDelElementComponent);
    }
};

PLUGIN(PortGraphDelElement)
