/**
 *
 * This file is part of Porgy (http://tulip.labri.fr/TulipDrupal/?q=porgy)
 *
 * from LaBRI, University of Bordeaux, Inria and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "animationconfigurationwidget.h"

#include "ui_animationconfigurationwidget.h"

AnimationConfigurationWidget::AnimationConfigurationWidget(QWidget *parent):QWidget(parent), ui(new Ui::AnimationConfigurationWidget) {
    ui->setupUi(this);    
    ui->rulePreviewGeometryComboBox->addItem(tr("No rule preview"),QVariant(static_cast<int>(No_Rule_Preview)));
    ui->rulePreviewGeometryComboBox->addItem(tr("Small preview"),QVariant(static_cast<int>(Small_Rule_Preview)));
    ui->rulePreviewGeometryComboBox->addItem(tr("Medium preview"),QVariant(static_cast<int>(Medium_Rule_Preview)));
    ui->rulePreviewGeometryComboBox->addItem(tr("Large preview"),QVariant(static_cast<int>(Large_Rule_Preview)));

    connect(ui->rulePreviewGeometryComboBox,SIGNAL(currentIndexChanged(int)),SIGNAL(rulePreviewGeometryChanged()));
}

AnimationConfigurationWidget::~AnimationConfigurationWidget()
{
    delete ui;
}

RulePreviewGeometry AnimationConfigurationWidget::rulePreviewGeometry()const{
    return static_cast<RulePreviewGeometry>(ui->rulePreviewGeometryComboBox->itemData(ui->rulePreviewGeometryComboBox->currentIndex()).toInt());
}

unsigned int AnimationConfigurationWidget::animationDuration()const{
    return ui->animationDurationSpinBox->value();
}

void AnimationConfigurationWidget::setAnimationDuration(unsigned duration) {
    return ui->animationDurationSpinBox->setValue(duration);
}

void AnimationConfigurationWidget::setRulePreviewGeometry(RulePreviewGeometry geometry) {
    ui->rulePreviewGeometryComboBox->setCurrentIndex(geometry);
}
