/**
 *
 * This file is part of Porgy (http://tulip.labri.fr/TulipDrupal/?q=porgy)
 *
 * from LaBRI, University of Bordeaux, Inria and King's College London
 *
 * Porgy is free software;  you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 *
 * Porgy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this Porgy.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef PORGYSMALLMULTIPLESTRACEVIEWINTERACTOR_H
#define PORGYSMALLMULTIPLESTRACEVIEWINTERACTOR_H

#include <tulip/InteractorComposite.h>

#include "glitemnavigationinteractor.h"

#include <portgraph/PorgyConstants.h>

class PorgySmallmultiplesTraceViewInteractor : public tlp::InteractorComposite
{
public:
    PLUGININFORMATION("PorgySmallMultipleNavigation","Jonathan Dubois","17/02/2011","","1.0",PorgyConstants::CATEGORY_NAME)
    PorgySmallmultiplesTraceViewInteractor(const tlp::PluginContext *);
    void construct();
    bool isCompatible(const std::string &viewName) const;

    unsigned int priority()const{
        return 0;
    }
    QWidget* configurationWidget() const{
    return nullptr;
    }

};

class PorgyTraceAnimationViewNavigationComponent : public tlp::InteractorComponent{

GlItemNavigationController _navigationController;
public:
    PorgyTraceAnimationViewNavigationComponent();
    void viewChanged(tlp::View *);
};

class PorgyTraceAnimationViewSelectionComponent : public tlp::InteractorComponent{

public:

    void viewChanged(tlp::View *);
    bool eventFilter(QObject *obj, QEvent *evt);
};

#endif // PORGYSMALLMULTIPLESTRACEVIEWINTERACTOR_H
