#include <tulip/Graph.h>
#include <tulip/TlpTools.h>
#include <tulip/PluginLoaderTxt.h>
#include <tulip/PluginLibraryLoader.h>

#include <cstdlib>

using namespace std;
using namespace tlp;

int main(int argc, char* argv[]) {

  if (argc!=2) {
      cerr << "Usage " << argv[0] << " path_to_tlp_graph" << endl;
      return EXIT_FAILURE;
  }
 
  tlp::initTulipLib();
  PluginLoaderTxt loader;
  tlp::PluginLibraryLoader::loadPlugins(&loader);
  
  Graph *g = tlp::loadGraph(argv[1]);
  if(g==NULL) {
    cerr << "error loading graph" << endl;
    return EXIT_FAILURE;
  }
  
  Graph *g0 = g->getDescendantGraph("G0");
  
  DataSet ds;
//  string strat("setPos(CrtGraph);R2;R2;R2;R2;R1;R1;R2;R2;R2;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R1;R1;R2;R2;R1;R2;R1;R2;R2;R2;R2;R2;R2;R2;R2;R1;R1;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R1;R2;R1;R2;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R1;R1;R2;R2;R2;R2;R2;R2;R2;R1;R1;R2;R1;R2;R2;R2;R2;R2;R2;R2;R2;R1;R2;R2;R1;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R1;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R2;R1");
 string strat("setPos(CrtGraph);repeat(ppick(R1, 0.11,R2,0.89),1000)");
  ds.set<string>("Strategy", strat);
 
  string errMsg;
  g0->applyAlgorithm("StrategySpirit", errMsg, &ds);

  if(errMsg.empty()&&tlp::saveGraph(g, "output.tlp")) {
      delete g;
      return EXIT_SUCCESS;
  }
  else {
      cerr << "Error: " << errMsg << endl;
      delete g;
      return EXIT_FAILURE;
  }
  
}
